<script>
  import { extent } from "d3-array";
  import { select } from "d3-selection";
  import { scaleLinear } from "d3-scale";
  import { axisBottom, axisLeft } from "d3-axis";
  import {brush} from "d3-brush";

  // Properties
  export let data = [];
  export let x = (d) => d.x;
  export let y = (d) => d.y;
  export let xLabel = "x";
  export let yLabel = "y";

  export let local_selection = [];
  export let global_selection = [];

  // Dimensions
  const width = 400;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 35, left: 45 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Scales
  const xScale = scaleLinear().domain(extent(data, x)).range([0, innerWidth]);
  const yScale = scaleLinear().domain(extent(data, y)).range([innerHeight, 0]);

  // Axes
  const xAxis = (node) => axisBottom(xScale)(select(node));
  const yAxis = (node) => axisLeft(yScale)(select(node));

  // Brushing
  // The range of the selection rectangle.
  // If there is no active selection, it contains: null,
  // otherwise, it contains: [ [x0, y0], [x1, y1] ]
  let range = null;
  let coords = [];
  let scatterBrush = brush().on("start brush end", handleBrush);
  let rnd_id = "id_" + getRandomInt(1, 100000);

  for (let i=0; i<data.length; i++){
    coords.push({x: xScale(x(data[i])), y:yScale(y(data[i]))});
  }

  function handleBrush(e){
    range = e.selection;
    update();
  }

  function getRandomInt(min, max) {
    min = Math.ceil(min);
    max = Math.floor(max);
    return Math.floor(Math.random() * (max - min) + min);
  }

  function initBrush(){
    select("#" + rnd_id).call(scatterBrush);
  }

  function isInBrushRange(c) {
    return  c.x >= range[0][0] &&
            c.x <= range[1][0] &&
            c.y >= range[0][1] &&
            c.y <= range[1][1];
  }

  function update(){
    for (let i=0; i<coords.length; i++){
      if(range != null){
        local_selection[i] = isInBrushRange(coords[i]);
      }else{
        local_selection[i] = true;
      }
    }
  }

  function localSelectionInit(){
    for (let i=0; i<coords.length; i++){
      local_selection.push(true);
    }
  }

  function getArrtibutes(status){
    if (!status){
      return {stroke:"darkgray", fill:"darkgray", fill_opacity:0.3, stroke_opacity:0.5};
    }else{
      return {stroke:"steelblue", fill:"steelblue", fill_opacity:0.5, stroke_opacity:1.5};
    }
  }

  localSelectionInit();
  $: update();

</script>

<svg viewBox="0 0 {width} {height}" class="mx-2" style="max-width: {width}px">
  <g  transform="translate({margin.left},{margin.top})">
    <g id="{rnd_id}" use:initBrush>
      {#each coords as c, idx}
        <circle
          cx={c.x}
          cy={c.y}
          r={3}
          fill="{getArrtibutes(global_selection[idx]).fill}"
          fill-opacity="{getArrtibutes(global_selection[idx]).fill_opacity}"
          stroke="{getArrtibutes(global_selection[idx]).stroke}"
          stroke-width="1.5"
          stroke-opacity="{getArrtibutes(global_selection[idx]).stroke_opacity}"
        />
      {/each}
    </g>
    <g use:xAxis transform="translate(0, {innerHeight})">
      <text class="axisLabel" x={innerWidth / 2} y={margin.bottom - 5}
        >{xLabel}</text>
    </g>
    <g use:yAxis>
      <text
        class="axisLabel"
        y={-margin.left + 10}
        x={-innerHeight / 2}
        transform="rotate(-90)">{yLabel}</text>
    </g>
  </g>
</svg>

<style>
  .axisLabel {
    text-anchor: middle;
    vertical-align: bottom;
    fill: currentcolor;
  }
</style>
